#include <tizen.h>
#include <service_app.h>
#include "$(appName).h"
#include <app_event.h>
#include <stdlib.h>
#include <notification.h>

bool service_app_create(void *data)
{
    // Todo: add your code here.
    return true;
}

void service_app_terminate(void *data)
{
    // Todo: add your code here.
    return;
}

void service_app_control(app_control_h app_control, void *data)
{
    // Todo: add your code here.
	int ret = 0;
	char *operation = NULL;
	char *uri = NULL;
	const char *title = "ServiceApp Noti";
	const char *content = NULL;

	dlog_print(DLOG_INFO, LOG_TAG, "service_app_control");

	ret = app_control_get_operation(app_control, &operation);

	if (ret == APP_CONTROL_ERROR_NONE && operation &&
		strncmp(operation, APP_CONTROL_OPERATION_LAUNCH_ON_EVENT, strlen(operation)) == 0){

		ret = app_control_get_uri(app_control, &uri);

		if (ret == APP_CONTROL_ERROR_NONE && uri) {
			if (strncmp(uri, "event://tizen.system.event.earjack_status", strlen(uri)) == 0) {
				content = "service is launched by earjack";
			} else if(strncmp(uri, "event://tizen.system.event.usb_status", strlen(uri)) == 0){
				content = "service is launched by usb";
			} else if(strncmp(uri, "event://tizen.system.event.battery_charger_status", strlen(uri)) == 0){
				content = "service is launched by charger";
			} else if(strncmp(uri, "event://tizen.system.event.incoming_msg", strlen(uri)) == 0){
				content = "service is launched by msg";
			}

			notification_h notify = notification_create(NOTIFICATION_TYPE_NOTI);

			notification_set_text(notify, NOTIFICATION_TEXT_TYPE_TITLE, title, NULL, NOTIFICATION_VARIABLE_TYPE_NONE);
			notification_set_text(notify, NOTIFICATION_TEXT_TYPE_CONTENT, content, NULL, NOTIFICATION_VARIABLE_TYPE_NONE);

			ret = notification_post(notify);

			if(ret != NOTIFICATION_ERROR_NONE)
				dlog_print(DLOG_INFO, LOG_TAG, "event service app noti error!");

			if(notify != NULL)
				notification_free(notify);

			free(uri);
		}
		free(operation);
	}

	return;
}

static void
service_app_lang_changed(app_event_info_h event_info, void *user_data)
{
	/*APP_EVENT_LANGUAGE_CHANGED*/
	return;
}

static void
service_app_orient_changed(app_event_info_h event_info, void *user_data)
{
	/*APP_EVENT_DEVICE_ORIENTATION_CHANGED*/
	return;
}

static void
service_app_region_changed(app_event_info_h event_info, void *user_data)
{
	/*APP_EVENT_REGION_FORMAT_CHANGED*/
}

static void
service_app_low_battery(app_event_info_h event_info, void *user_data)
{
	/*APP_EVENT_LOW_BATTERY*/
}

static void
service_app_low_memory(app_event_info_h event_info, void *user_data)
{
	/*APP_EVENT_LOW_MEMORY*/
}

int main(int argc, char* argv[])
{
    char ad[50] = {0,};
	service_app_lifecycle_callback_s event_callback;
	app_event_handler_h handlers[5] = {NULL, };

	event_callback.create = service_app_create;
	event_callback.terminate = service_app_terminate;
	event_callback.app_control = service_app_control;

	service_app_add_event_handler(&handlers[APP_EVENT_LOW_BATTERY], APP_EVENT_LOW_BATTERY, service_app_low_battery, &ad);
	service_app_add_event_handler(&handlers[APP_EVENT_LOW_MEMORY], APP_EVENT_LOW_MEMORY, service_app_low_memory, &ad);
	service_app_add_event_handler(&handlers[APP_EVENT_DEVICE_ORIENTATION_CHANGED], APP_EVENT_DEVICE_ORIENTATION_CHANGED, service_app_orient_changed, &ad);
	service_app_add_event_handler(&handlers[APP_EVENT_LANGUAGE_CHANGED], APP_EVENT_LANGUAGE_CHANGED, service_app_lang_changed, &ad);
	service_app_add_event_handler(&handlers[APP_EVENT_REGION_FORMAT_CHANGED], APP_EVENT_REGION_FORMAT_CHANGED, service_app_region_changed, &ad);

	return service_app_main(argc, argv, &event_callback, ad);
}
